=== debian/changelog ===
libsdl3-mixer (3.1.2+git20260204~9ea9abe+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/watch: Watch for git snapshots again
  * d/copyright: Update
  * d/rules, d/libsdl3-mixer-tests.install: Build and install examples
  * d/rules: Don't make sample audio files executable
  * Revert "Update Lintian overrides for use of a release tarball"
  * Stop installing a compiled docs/hello.c as simple-player.
    It's functionally redundant with testaudiodecoder.
  * d/rules: Remove unnecessary dh_compress override

 -- Simon McVittie <smcv@debian.org>  Wed, 04 Feb 2026 19:12:16 +0000
